diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_kill.c ircd-hybrid-fuis/modules/m_kill.c
--- ircd-hybrid-7.0rc9/modules/m_kill.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-fuis/modules/m_kill.c	Wed Mar 12 16:24:15 2003
@@ -0,0 +1,385 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_kill.c: Kills a user.
+ *
+ *  Copyright (C) 2002 by the past and present ircd coders, and others.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_kill.c,v 1.68 2003/02/14 23:01:53 db Exp $
+ */
+
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "hash.h"       /* for find_client() */
+#include "ircd.h"
+#include "numeric.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "s_conf.h"
+#include "send.h"
+#include "whowas.h"
+#include "irc_string.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+
+static char buf[BUFSIZE];
+
+static void ms_kill(struct Client*, struct Client*, int, char**);
+static void mo_kill(struct Client*, struct Client*, int, char**);
+static void relay_kill(struct Client *, struct Client *, struct Client *,
+                       const char *, const char *);
+
+struct Message kill_msgtab = {
+  "KILL", 0, 0, 2, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_not_oper, ms_kill, mo_kill}
+};
+#ifndef STATIC_MODULES
+
+void
+_modinit(void)
+{
+  mod_add_cmd(&kill_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&kill_msgtab);
+}
+
+const char *_version = "$Revision: 1.68 $";
+#endif
+/*
+** mo_kill
+**      parv[0] = sender prefix
+**      parv[1] = kill victim
+**      parv[2] = kill path
+*/
+static void
+mo_kill(struct Client *client_p, struct Client *source_p,
+	int parc, char *parv[])
+{
+  struct Client*    target_p;
+  const char* inpath = client_p->name;
+  char*       user;
+  char*       reason;
+
+  user = parv[1];
+  reason = parv[2]; /* Either defined or NULL (parc >= 2!!) */
+
+  if (!IsOperK(source_p))
+    {
+      sendto_one(source_p,":%s NOTICE %s :You need kline = yes;",me.name,parv[0]);
+      return;
+    }
+
+  if (!irccmp(parv[0], parv[1]))
+  {
+   sendto_one(source_p, ":%s NOTICE %s :You can't kill yourself!", me.name, parv[0]);
+   return;
+  }
+
+  if (!BadPtr(reason))
+    {
+      if(strlen(reason) > (size_t) KILLLEN)
+	reason[KILLLEN] = '\0';
+    }
+  else
+    reason = "<No reason given>";
+
+  if ((target_p = find_client(user)) == NULL)
+    {
+      /*
+      ** If the user has recently changed nick, automatically
+      ** rewrite the KILL for this new nickname--this keeps
+      ** servers in synch when nick change and kill collide
+      */
+      if ((target_p = get_history(user, (long)KILLCHASETIMELIMIT)) == NULL)
+        {
+          sendto_one(source_p, form_str(ERR_NOSUCHNICK),
+                     me.name, parv[0], user);
+          return;
+        }
+      sendto_one(source_p,":%s NOTICE %s :KILL changed from %s to %s",
+                 me.name, parv[0], user, target_p->name);
+    }
+  if (IsServer(target_p) || IsMe(target_p))
+    {
+      sendto_one(source_p, form_str(ERR_CANTKILLSERVER),
+                 me.name, parv[0]);
+      return;
+    }
+
+  if (!MyConnect(target_p) && (!IsOperGlobalKill(source_p)))
+    {
+      sendto_one(source_p, ":%s NOTICE %s :Nick %s isnt on your server",
+                 me.name, parv[0], target_p->name);
+      return;
+    }
+
+  if(MyConnect(target_p))
+    sendto_one(target_p, ":%s!%s@%s KILL %s :%s", 
+	       source_p->name, source_p->username, source_p->host,
+	       target_p->name, reason);
+
+  /* Do not change the format of this message.  There's no point in changing messages
+   * that have been around for ever, for no reason.. */
+  sendto_realops_flags(FLAGS_ALL, L_ALL,
+		       "Received KILL message for %s. From %s Path: %s (%s)", 
+		       target_p->name, parv[0], me.name, reason);
+
+  ilog(L_INFO,"KILL From %s For %s Path %s (%s)",
+       parv[0], target_p->name, me.name, reason);
+
+
+  /*
+  ** And pass on the message to other servers. Note, that if KILL
+  ** was changed, the message has to be sent to all links, also
+  ** back.
+  ** Suicide kills are NOT passed on --SRB
+  */
+  if (!MyConnect(target_p))
+    {
+      relay_kill(client_p, source_p, target_p, inpath, reason);
+      /*
+      ** Set FLAGS_KILLED. This prevents exit_one_client from sending
+      ** the unnecessary QUIT for this. (This flag should never be
+      ** set in any other place)
+      */
+      target_p->flags |= FLAGS_KILLED;
+    }
+
+  ircsprintf(buf, "Killed (%s (%s))", source_p->name, reason);
+  
+  exit_client(client_p, target_p, source_p, buf);
+}
+
+/*
+ * ms_kill
+ *      parv[0] = sender prefix
+ *      parv[1] = kill victim
+ *      parv[2] = kill path and reason
+ */
+static void
+ms_kill(struct Client *client_p, struct Client *source_p,
+	int parc, char *parv[])
+{
+  struct Client *target_p;
+  char *user;
+  char *reason;
+  char *path;
+  int chasing = 0;
+
+  *buf = '\0';
+
+  if (*parv[1] == '\0')
+    {
+      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+                 me.name, parv[0], "KILL");
+      return;
+    }
+
+  if (!irccmp(parv[0], parv[1]))
+  {
+   sendto_one(source_p, ":%s NOTICE %s :You can't kill yourself!", me.name, parv[0]);
+   return;
+  }
+
+  user = parv[1];
+
+  if(BadPtr(parv[2]))
+  {
+    reason = "<No reason given>";
+
+    /* hyb6 takes the nick of the killer from the path *sigh* --fl_ */
+    path = source_p->name;
+  }
+  else
+  {
+    reason = strchr(parv[2], ' ');
+      
+    if(reason)
+    {
+      *reason = '\0';
+      reason++;
+    }
+    else
+      reason = "<No reason given>";
+
+    path = parv[2];
+  }
+
+  if ((target_p = find_client(user)) == NULL)
+    {
+      /*
+       * If the user has recently changed nick, but only if its 
+       * not an uid, automatically rewrite the KILL for this new nickname.
+       * --this keeps servers in synch when nick change and kill collide
+       */
+      if( (*user == '.')  ||
+	  (!(target_p = get_history(user, (long)KILLCHASETIMELIMIT))))
+        {
+          sendto_one(source_p, form_str(ERR_NOSUCHNICK),
+                     me.name, parv[0], user);
+          return;
+        }
+      sendto_one(source_p,":%s NOTICE %s :KILL changed from %s to %s",
+                 me.name, parv[0], user, target_p->name);
+      chasing = 1;
+    }
+    
+  if (IsServer(target_p) || IsMe(target_p))
+    {
+      sendto_one(source_p, form_str(ERR_CANTKILLSERVER),
+                 me.name, parv[0]);
+      return;
+    }
+
+  if(MyConnect(target_p))
+  {
+    if(IsServer(source_p))
+    {
+      /* dont send clients kills from a hidden server */
+      if(ConfigServerHide.hide_servers && !IsOper(target_p))
+        sendto_one(target_p, ":%s KILL %s :%s",
+ 		   me.name, target_p->name, reason);
+      else
+	sendto_one(target_p, ":%s KILL %s :%s",
+	           source_p->name, target_p->name, reason);
+    }
+    else
+      sendto_one(target_p, ":%s!%s@%s KILL %s :%s",
+		 source_p->name, source_p->username, source_p->host,
+		 target_p->name, reason);
+  }
+
+  /* Be warned, this message must be From %s, or it confuses clients
+   * so dont change it to From: or the case or anything! -- fl -- db */
+  /* path must contain at least 2 !'s, or bitchx falsely declares it
+   * local --fl
+   */
+  if (IsOper(source_p)) /* send it normally */
+    {
+      sendto_realops_flags(FLAGS_ALL, L_ALL,
+		"Received KILL message for %s. From %s Path: %s!%s!%s!%s %s",
+		target_p->name, parv[0], source_p->user->server, 
+                source_p->host, source_p->username, source_p->name, reason);
+    }
+  else
+    {
+      sendto_realops_flags(FLAGS_SKILL, L_ALL,
+			   "Received KILL message for %s. From %s %s",
+			   target_p->name, parv[0], reason);
+    }
+
+  ilog(L_INFO,"KILL From %s For %s Path %s %s",
+       parv[0], target_p->name, parv[0], reason);
+
+  relay_kill(client_p, source_p, target_p, path, reason);
+
+  /* FLAGS_KILLED prevents a quit being sent out */ 
+  SetKilled(target_p);
+
+  /* reason comes supplied with its own ()'s */
+  if(ConfigServerHide.hide_servers && IsServer(source_p))
+    ircsprintf(buf, "Killed (%s %s)", me.name, reason);
+  else
+    ircsprintf(buf, "Killed (%s %s)", source_p->name, reason);
+    
+  exit_client(client_p, target_p, source_p, buf);
+}
+
+static void
+relay_kill(struct Client *one, struct Client *source_p,
+	   struct Client *target_p, const char *inpath, const char *reason)
+{
+  dlink_node *ptr;
+  struct Client *client_p;
+  int introduce_killed_client;
+  char* user; 
+  
+  /* LazyLinks:
+   * Check if each lazylink knows about target_p.
+   *   If it does, send the kill, introducing source_p if required.
+   *   If it doesn't either:
+   *     a) don't send the kill (risk ghosts)
+   *     b) introduce the client (and source_p, if required)
+   *        [rather redundant]
+   *
+   * Use a) if IsServer(source_p), but if an oper kills someone,
+   * ensure we blow away any ghosts.
+   *
+   * -davidt
+   */
+
+  if(IsServer(source_p))
+    introduce_killed_client = 0;
+  else
+    introduce_killed_client = 1;
+
+  for( ptr = serv_list.head; ptr; ptr = ptr->next )
+  {
+    client_p = (struct Client *) ptr->data;
+    
+    if( !client_p || client_p == one )
+      continue;
+
+    if( !introduce_killed_client )
+    {
+      if( ServerInfo.hub && IsCapable(client_p, CAP_LL) )
+      {
+        if(((client_p->localClient->serverMask &
+             target_p->lazyLinkClientExists) == 0))
+        {
+          /* target isn't known to lazy leaf, skip it */
+          continue;
+        }
+      }
+    }
+    /* force introduction of killed client but check that
+     * its not on the server we're bursting too.. */
+    else if(strcmp(target_p->user->server,client_p->name))
+      client_burst_if_needed(client_p, target_p);
+
+    /* introduce source of kill */
+    client_burst_if_needed(client_p, source_p);
+
+    /* check the server supports UID */
+    if (IsCapable(client_p, CAP_UID))
+      user = ID(target_p);
+    else
+      user = target_p->name;
+
+    if(MyClient(source_p))
+      {
+        sendto_one(client_p, ":%s KILL %s :%s!%s!%s!%s (%s)",
+                   source_p->name, user,
+                   me.name, source_p->host, source_p->username,
+                   source_p->name, reason);
+      }
+    else
+      {
+        sendto_one(client_p, ":%s KILL %s :%s %s",
+                   source_p->name, user,
+                   inpath, reason);
+      }
+  }
+}
+
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_kline.c ircd-hybrid-fuis/modules/m_kline.c
--- ircd-hybrid-7.0rc9/modules/m_kline.c	Wed Nov 13 08:12:02 2002
+++ ircd-hybrid-fuis/modules/m_kline.c	Sun Feb  9 08:21:20 2003
@@ -235,18 +235,20 @@
   if (tkline_time)
     {
       ircsprintf(buffer,
-		 "Temporary K-line %d min. - %s (%s)",
+		 "Temporary K-line %d min. - %s (%s by %s)",
 		 (int)(tkline_time/60),
 		 reason,
-		 current_date);
+		 current_date,
+		 source_p->name);
       DupString(aconf->passwd, buffer);
       apply_tkline(source_p, aconf, current_date, tkline_time);
     }
   else
     {
-      ircsprintf(buffer, "%s (%s)",
+      ircsprintf(buffer, "%s (%s by %s)",
 		 reason,
-		 current_date);
+		 current_date,
+		 source_p->name);
       DupString(aconf->passwd, buffer);
       apply_kline(source_p, aconf, reason, oper_reason,
 		  current_date, cur_time);
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_links.c ircd-hybrid-fuis/modules/m_links.c
--- ircd-hybrid-7.0rc9/modules/m_links.c	Wed Jul 31 12:24:07 2002
+++ ircd-hybrid-fuis/modules/m_links.c	Tue Feb 11 08:20:50 2003
@@ -51,14 +51,12 @@
 void
 _modinit(void)
 {
-	hook_add_event("doing_links");
   mod_add_cmd(&links_msgtab);
 }
 
 void
 _moddeinit(void)
 {
-	hook_del_event("doing_links");
   mod_del_cmd(&links_msgtab);
 }
 
@@ -77,6 +75,18 @@
 static void m_links(struct Client *client_p, struct Client *source_p,
                    int parc, char *parv[])
 {
+  sendto_realops_flags(FLAGS_SPY, L_ALL,
+               "LINKS requested by %s (%s@%s) [%s]",
+               source_p->name, source_p->username,
+               source_p->host, source_p->user->server);
+
+  if (!IsOper(source_p))
+  {
+    sendto_one(source_p, form_str(RPL_LINKSUSERS),
+  	           me.name, parv[0], ConfigFileEntry.network_server_site);
+	return;
+  }
+
   if (!ConfigServerHide.flatten_links)
     {
       mo_links(client_p, source_p, parc, parv);
@@ -104,7 +114,6 @@
   struct Client* target_p;
   char           clean_mask[2 * HOSTLEN + 4];
   char*          p;
-  struct hook_links_data hd;
   
   dlink_node *ptr;
 
@@ -127,14 +136,7 @@
   if (*mask)       /* only necessary if there is a mask */
     mask = collapse(clean_string(clean_mask, (const unsigned char*) mask, 2 * HOSTLEN));
 
-  hd.client_p = client_p;
-  hd.source_p = source_p;
-  hd.mask = mask;
-  hd.parc = parc;
-  hd.parv = parv;
-  
-  hook_call_event("doing_links", &hd);
-  
+
   for (ptr = global_serv_list.head; ptr; ptr = ptr->next)
     {
       target_p = ptr->data;
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_list.c ircd-hybrid-fuis/modules/m_list.c
--- ircd-hybrid-7.0rc9/modules/m_list.c	Fri Jan 17 00:11:53 2003
+++ ircd-hybrid-fuis/modules/m_list.c	Sun Feb  9 08:21:20 2003
@@ -245,7 +245,7 @@
 #endif
     ircsprintf(id_and_topic, "%s", chptr->topic == NULL ? "" : chptr->topic);
 
-  if (ShowChannel(source_p, chptr))
+  if (ShowChannel(source_p, chptr) && chptr->users > 2)
     sendto_one(source_p, form_str(RPL_LIST), me.name, source_p->name,
                chptr->chname, chptr->users, id_and_topic);
       
@@ -256,7 +256,7 @@
     {
       tmpchptr = ptr->data;
 
-      if (ShowChannel(source_p, tmpchptr))
+      if (ShowChannel(source_p, tmpchptr) && chptr->users > 2)
 	{
           root_chptr = find_bchan(tmpchptr);
           ircsprintf(id_and_topic, "<!%s> %s", pick_vchan_id(tmpchptr), tmpchptr->topic == NULL ? "" : chptr->topic);
@@ -288,20 +288,20 @@
     {
       root_chptr = find_bchan(chptr);
       
-      if(root_chptr != NULL)
+      if(root_chptr != NULL && chptr->users > 2)
         {
           ircsprintf(id_and_topic, "<!%s> %s", pick_vchan_id(chptr), chptr->topic == NULL ? "" : chptr->topic );
           sendto_one(source_p, form_str(RPL_LIST), me.name, source_p->name,
                      root_chptr->chname, chptr->users, id_and_topic);
         }
-      else
+      else if (chptr->users > 2)
         {
           ircsprintf(id_and_topic, "<!%s> %s", pick_vchan_id(chptr), chptr->topic == NULL ? "" : chptr->topic );
           sendto_one(source_p, form_str(RPL_LIST), me.name, source_p->name,
                      chptr->chname, chptr->users, id_and_topic);     
         }
     }
-  else
+  else if (chptr->users > 2)
 #endif
     {
       sendto_one(source_p, form_str(RPL_LIST), me.name, source_p->name,
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_ltrace.c ircd-hybrid-fuis/modules/m_ltrace.c
--- ircd-hybrid-7.0rc9/modules/m_ltrace.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-fuis/modules/m_ltrace.c	Tue Feb 11 08:21:08 2003
@@ -0,0 +1,374 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_ltrace.c: Traces a path to a client/server.
+ *
+ *  Copyright (C) 2002 Hybrid Development Team
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_ltrace.c,v 1.4 2002/07/31 22:52:58 leeh Exp $
+ */
+
+#include "stdinc.h"
+#include "handlers.h"
+#include "class.h"
+#include "hook.h"
+#include "client.h"
+#include "hash.h"
+#include "common.h"
+#include "hash.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "fdlist.h"
+#include "s_bsd.h"
+#include "s_serv.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+
+static void m_ltrace(struct Client *, struct Client *, int, char **);
+static void mo_ltrace(struct Client*, struct Client*, int, char**);
+static struct Client* next_client_double(struct Client *next, const char* ch);
+static void ltrace_spy(struct Client *);
+
+struct Message ltrace_msgtab = {
+  "LTRACE", 0, 0, 0, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_ltrace, mo_ltrace, mo_ltrace}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&ltrace_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&ltrace_msgtab);
+}
+
+const char *_version = "$Revision: 1.4 $";
+#endif
+
+static int report_this_status(struct Client *source_p, struct Client *target_p,int dow,
+                              int link_u_p, int link_u_s);
+
+/*
+ * m_ltrace()
+ *
+ *	parv[0] = sender prefix
+ *	parv[1] = target client/server to trace
+ */
+static void m_ltrace(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+  char *tname;
+
+  if (parc > 1)
+    tname = parv[1];
+  else
+    tname = me.name;
+  sendto_one(source_p, form_str(RPL_ENDOFTRACE), me.name, parv[0], tname);
+}
+
+/*
+ * mo_ltrace
+ *      parv[0] = sender prefix
+ *      parv[1] = servername
+ */
+static void mo_ltrace(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+  struct Client       *target_p = NULL;
+  char  *tname;
+  int   doall, link_s[MAXCONNECTIONS], link_u[MAXCONNECTIONS];
+  int   wilds, dow;
+  dlink_node *ptr;
+  char *looking_for = parv[0];
+
+  if(!IsClient(source_p))
+    return;
+
+  if (parc > 1)
+    tname = parv[1];
+  else
+    tname = me.name;
+
+  if(!IsOper(source_p))
+  {
+    sendto_one(source_p, form_str(RPL_ENDOFTRACE), me.name, parv[0], tname);
+    return;
+  }
+
+  if (parc > 2)
+    if (hunt_server(client_p, source_p, ":%s LTRACE %s :%s", 2, parc, parv))
+      return;
+
+  switch (hunt_server(client_p, source_p, ":%s LTRACE :%s", 1, parc, parv))
+    {
+    case HUNTED_PASS: /* note: gets here only if parv[1] exists */
+      {
+        struct Client *ac2ptr;
+        
+        ac2ptr = next_client_double(GlobalClientList, tname);
+        if (ac2ptr)
+          sendto_one(source_p, form_str(RPL_TRACELINK), me.name, looking_for,
+                     ircd_version, debugmode, tname, ac2ptr->from->name);
+        else
+          sendto_one(source_p, form_str(RPL_TRACELINK), me.name, looking_for,
+                     ircd_version, debugmode, tname, "ac2ptr_is_NULL!!");
+        return;
+      }
+    case HUNTED_ISME:
+      break;
+    default:
+      return;
+    }
+
+  ltrace_spy(source_p);
+
+  doall = (parv[1] && (parc > 1)) ? match(tname, me.name): TRUE;
+  wilds = !parv[1] || strchr(tname, '*') || strchr(tname, '?');
+  dow = wilds || doall;
+  
+  set_time();
+
+  /* lusers cant issue ltrace.. */
+  if(!IsOper(source_p) || !dow)
+    {
+      const char* name;
+      const char* class_name;
+      char ipaddr[HOSTIPLEN];
+
+      target_p = find_client(tname);
+      
+      if(target_p && IsPerson(target_p)) 
+      {
+        name = get_client_name(target_p, HIDE_IP);
+        inetntop(target_p->localClient->aftype, &IN_ADDR(target_p->localClient->ip), ipaddr, HOSTIPLEN);
+
+        class_name = get_client_class(target_p);
+
+        if (IsOper(target_p))
+          sendto_one(source_p, form_str(RPL_TRACEOPERATOR),
+                     me.name, parv[0], class_name, name, 
+#ifndef HIDE_SPOOF_IPS
+                     MyOper(source_p) ? ipaddr :
+#endif
+		     (IsIPSpoof(target_p) ? "255.255.255.255" : ipaddr),
+                     CurrentTime - target_p->lasttime,
+                     (target_p->user) ? (CurrentTime - target_p->user->last) : 0);
+      }
+      
+      sendto_one(source_p, form_str(RPL_ENDOFTRACE),me.name,
+                 parv[0], tname);
+      return;
+    }
+
+  memset((void *)link_s,0,sizeof(link_s));
+  memset((void *)link_u,0,sizeof(link_u));
+
+  /*
+   * Count up all the servers and clients in a downlink.
+   */
+  if (doall)
+   {
+    for (target_p = GlobalClientList; target_p; target_p = target_p->next)
+     {
+      if (IsPerson(target_p))
+        {
+          link_u[target_p->from->localClient->fd]++;
+        }
+      else if (IsServer(target_p))
+	{
+	  link_s[target_p->from->localClient->fd]++;
+	}
+     }
+   }
+   
+  /* report all opers */
+  for (ptr = lclient_list.head; ptr; ptr = ptr->next)
+    {
+      target_p = ptr->data;
+
+      if(!IsOper(target_p))
+	continue;
+
+      if (!doall && wilds && !match(tname, target_p->name))
+        continue;
+
+      if (!dow && irccmp(tname, target_p->name))
+        continue;
+
+      report_this_status(source_p,target_p,dow,0,0);
+    }
+
+  /* report all servers */
+  for (ptr = serv_list.head; ptr; ptr = ptr->next)
+    {
+      target_p = ptr->data;
+
+      if (!doall && wilds && !match(tname, target_p->name))
+        continue;
+      if (!dow && irccmp(tname, target_p->name))
+        continue;
+
+      report_this_status(source_p, target_p, dow,
+                               link_u[target_p->localClient->fd],
+                               link_s[target_p->localClient->fd]);
+    }
+
+  sendto_one(source_p, form_str(RPL_ENDOFTRACE),me.name, parv[0],tname);
+}
+
+
+
+
+/*
+ * report_this_status
+ *
+ * inputs	- pointer to client to report to
+ * 		- pointer to client to report about
+ * output	- counter of number of hits
+ * side effects - NONE
+ */
+static int report_this_status(struct Client *source_p, struct Client *target_p,
+                              int dow, int link_u_p, int link_s_p)
+{
+  const char* name;
+  const char* class_name;
+  char  ip[HOSTIPLEN];
+
+  inetntop(target_p->localClient->aftype, &IN_ADDR(target_p->localClient->ip), ip, HOSTIPLEN);
+  name = get_client_name(target_p, HIDE_IP);
+  class_name = get_client_class(target_p);
+
+  set_time();
+
+  switch(target_p->status)
+    {
+    case STAT_CONNECTING:
+      sendto_one(source_p, form_str(RPL_TRACECONNECTING), me.name,
+                 source_p->name, class_name, 
+		 IsOperAdmin(source_p) ? name : target_p->name);
+		   
+      break;
+
+    case STAT_HANDSHAKE:
+      sendto_one(source_p, form_str(RPL_TRACEHANDSHAKE), me.name,
+                 source_p->name, class_name, 
+                 IsOperAdmin(source_p) ? name : target_p->name);
+		   
+      break;
+      
+    case STAT_ME:
+    case STAT_UNKNOWN:
+      break;
+
+    case STAT_CLIENT:
+      if (IsAdmin(target_p))
+	sendto_one(source_p, form_str(RPL_TRACEOPERATOR),
+                   me.name, source_p->name, class_name, name,
+#ifndef HIDE_SPOOF_IPS
+                   IsOperAdmin(source_p) ? ip : 
+#endif
+                   (IsIPSpoof(target_p) ? "255.255.255.255" : ip),
+                   CurrentTime - target_p->lasttime,
+                   (target_p->user) ? (CurrentTime - target_p->user->last) : 0);
+		       
+      else if (IsOper(target_p))
+	sendto_one(source_p, form_str(RPL_TRACEOPERATOR),
+		   me.name, source_p->name, class_name, name, 
+#ifndef HIDE_SPOOF_IPS
+		   MyOper(source_p) ? ip : 
+#endif
+		   (IsIPSpoof(target_p) ? "255.255.255.255" : ip),
+		   CurrentTime - target_p->lasttime,
+		   (target_p->user)?(CurrentTime - target_p->user->last):0);
+
+      break;
+    case STAT_SERVER:
+      if(!IsOperAdmin(source_p))
+        name = get_client_name(target_p, MASK_IP);
+
+      sendto_one(source_p, form_str(RPL_TRACESERVER),
+		 me.name, source_p->name, class_name, link_s_p,
+		 link_u_p, name, *(target_p->serv->by) ?
+		 target_p->serv->by : "*", "*",
+		 me.name, CurrentTime - target_p->lasttime);
+      break;
+      
+    default: /* ...we actually shouldn't come here... --msa */
+      sendto_one(source_p, form_str(RPL_TRACENEWTYPE), me.name,
+		 source_p->name, name);
+      break;
+    }
+
+  return 0;
+}
+
+/* ltrace_spy()
+ *
+ * input        - pointer to client
+ * output       - none
+ * side effects - hook event doing_trace is called
+ */
+static void ltrace_spy(struct Client *source_p)
+{
+  sendto_realops_flags(FLAGS_SPY, L_ALL,
+           "ltrace requested by %s (%s@%s) [%s]",
+		   source_p->name, source_p->username,
+		   source_p->host, source_p->user->server);
+}
+
+/* 
+ * this slow version needs to be used for hostmasks *sigh
+ *
+ * next_client_double - find the next matching client. 
+ * The search can be continued from the specified client entry. 
+ * Normal usage loop is:
+ *
+ *      for (x = client; x = next_client_double(x,mask); x = x->next)
+ *              HandleMatchingClient;
+ *            
+ */
+static struct Client* 
+next_client_double(struct Client *next, /* First client to check */
+                   const char* ch)      /* search string (may include wilds) */
+{
+  struct Client *tmp = next;
+
+  next = find_client(ch);
+
+  if (next == NULL)
+    next = tmp;
+
+  if (tmp && tmp->prev == next)
+    return NULL;
+  if (next != tmp)
+    return next;
+  for ( ; next; next = next->next)
+    {
+      if (match(ch,next->name) || match(next->name,ch))
+        break;
+    }
+  return next;
+}
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_map.c ircd-hybrid-fuis/modules/m_map.c
--- ircd-hybrid-7.0rc9/modules/m_map.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-fuis/modules/m_map.c	Wed Feb 19 08:08:33 2003
@@ -0,0 +1,163 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_map.c: Sends an Undernet compatible map to a user.
+ *
+ *  Copyright (C) 2002 by the past and present ircd coders, and others.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_map.c,v 1.12 2002/05/24 23:48:34 androsyn Exp $
+ */
+
+#include "stdinc.h"
+#include "client.h"
+#include "modules.h"
+#include "handlers.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_conf.h"
+
+#define USER_COL       50 /* display | Users: %d at col 50 */
+
+static void m_map(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+static void mo_map(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+static void dump_map(struct Client *client_p,struct Client *root, char *pbuf);
+
+struct Message map_msgtab = {
+  "MAP", 0, 0, 0, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_map, m_ignore, mo_map}
+};
+
+#ifndef STATIC_MODULES
+void _modinit(void)
+{
+  mod_add_cmd(&map_msgtab);
+}
+
+void _moddeinit(void)
+{
+  mod_del_cmd(&map_msgtab);
+}
+
+const char *_version = "$Revision: 1.12 $";
+#endif
+
+static char buf[BUFSIZE];
+
+/* m_map
+**	parv[0] = sender prefix
+*/
+static void m_map(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+  if (!IsOper(source_p))
+    {
+       sendto_one(source_p, form_str(RPL_LINKSUSERS),
+       me.name, parv[0], ConfigFileEntry.network_server_site);
+       return;
+}
+
+  if (!ConfigServerHide.flatten_links)
+  {
+    dump_map(client_p,&me,buf);
+    sendto_one(client_p, form_str(RPL_MAPEND), me.name, client_p->name);
+    return;
+  }
+
+  m_not_oper(client_p,source_p,parc,parv);
+  return;
+}
+
+/*
+** mo_map
+**      parv[0] = sender prefix
+*/
+static void mo_map(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+  dump_map(client_p,&me,buf);
+  sendto_one(client_p, form_str(RPL_MAPEND), me.name, client_p->name);
+}
+
+/*
+** dump_map
+**   dumps server map, called recursively.
+*/
+static void dump_map(struct Client *client_p,struct Client *root_p, char *pbuf)
+{
+  int cnt = 0, i = 0, len;
+  int users = 0;
+  struct Client *server_p,*user_p;
+        
+  *pbuf= '\0';
+       
+  strncat(pbuf,root_p->name,BUFSIZE - ((size_t) pbuf - (size_t) buf));
+  len = strlen(buf);
+  buf[len] = ' ';
+	
+  if (len < USER_COL)
+  {
+     for (i = len+1; i < USER_COL; i++)
+     {
+       buf[i] = '-';
+     }
+  }
+	
+  /* FIXME: add serv->usercnt */
+  for( user_p = root_p->serv->users; user_p; user_p = user_p->lnext )
+    users++;
+        
+  snprintf(buf + USER_COL, BUFSIZE - USER_COL,
+           " | Users: %5d (%4.1f%%)", users,
+           100 * (float) users / (float) Count.total);
+        
+  sendto_one(client_p, form_str(RPL_MAP),me.name,client_p->name,buf);
+        
+  if ((server_p = root_p->serv->servers))
+  {
+    for (; server_p; server_p = server_p->lnext)
+    {
+      cnt++;
+    }
+    
+    if (cnt)
+    {
+      if (pbuf > buf + 3)
+      {
+        pbuf[-2] = ' ';
+        if (pbuf[-3] == '`')
+          pbuf[-3] = ' ';
+      }
+    }
+  }
+  for (i = 1,server_p = root_p->serv->servers; server_p; server_p=server_p->lnext)
+  {
+    *pbuf = ' ';
+    if (i < cnt)
+      *(pbuf + 1) = '|';
+    else
+      *(pbuf + 1) = '`';
+      
+    *(pbuf + 2) = '-';
+    *(pbuf + 3) = ' ';
+    dump_map(client_p,server_p,pbuf+4);
+ 
+    i++;
+   }
+}
+
